<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>LibraryMgr: app/Library/Library.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LibraryMgr
   &#160;<span id="projectnumber">0.4</span>
   </div>
   <div id="projectbrief">Library manager desktop app</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_library_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Library.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#ifndef LIBRARYMGR_LIBRARY_H</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#define LIBRARYMGR_LIBRARY_H</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;ostream&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &quot;../../models/People/User/User.h&quot;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &quot;../../models/People/Admin/Admin.h&quot;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &quot;../../utils/SmartPointer/SmartPointer.h&quot;</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="class_library.html">   31</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_library.html">Library</a> {</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="comment">// constructors</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <a class="code" href="class_library.html#a82338219d8bf51962ff5f60a0db21b19">Library</a>();</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <a class="code" href="class_library.html#a82338219d8bf51962ff5f60a0db21b19">Library</a>(<span class="keyword">const</span> <a class="code" href="class_library.html">Library</a> &amp;l);</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <a class="code" href="class_library.html#a62120f28a9b50cc5b151d868e42ab936">~Library</a>();</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="comment">// setters</span></div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_library.html#ad6479360c5ecb4592ab7df4cedc1d331">addUser</a>(<a class="code" href="class_smart_pointer.html">SmartPointer&lt;User&gt;</a> user);</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_library.html#ae18b352bb538f8f7bbef5eba963feec6">addBook</a>(<a class="code" href="class_smart_pointer.html">SmartPointer&lt;Book&gt;</a> book);</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_library.html#a237a223c72cc9c46efbc70b05bfc4067">removeUser</a>(<a class="code" href="class_smart_pointer.html">SmartPointer&lt;User&gt;</a> user);</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_library.html#a553976ddb2812ca85f16d98e747e7e69">removeBook</a>(<a class="code" href="class_smart_pointer.html">SmartPointer&lt;Book&gt;</a> book);</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_library.html#ad102e94fb61ef4db352769970c470ffe">editUser</a>(<a class="code" href="class_smart_pointer.html">SmartPointer&lt;User&gt;</a> oldUser, <a class="code" href="class_smart_pointer.html">SmartPointer&lt;User&gt;</a> newUser);</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_library.html#a983f569333bcca8e312e28faf4c31299">editBook</a>(<a class="code" href="class_smart_pointer.html">SmartPointer&lt;Book&gt;</a> oldBook, <a class="code" href="class_smart_pointer.html">SmartPointer&lt;Book&gt;</a> newBook);</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    <span class="comment">// getters</span></div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_library.html#a578ce2622f10276289f4818f745ab67e">isUserInDatabase</a>(<a class="code" href="class_user.html">User</a> user) <span class="keyword">const</span>;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_library.html#a9b67293035c9287e553fdf375c2c07d4">isBookInDatabase</a>(<a class="code" href="class_book.html">Book</a> book) <span class="keyword">const</span>;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <a class="code" href="class_smart_pointer.html">SmartPointer&lt;User&gt;</a> <a class="code" href="class_library.html#a525d14bedae90669616814e7bc8b64d2">findUser</a>(<a class="code" href="class_smart_pointer.html">SmartPointer&lt;User&gt;</a> user) <span class="keyword">const</span>;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <a class="code" href="class_smart_pointer.html">SmartPointer&lt;Book&gt;</a> <a class="code" href="class_library.html#a1e4254bc287282e010057c3e5badb43b">findBook</a>(<a class="code" href="class_smart_pointer.html">SmartPointer&lt;Book&gt;</a> book) <span class="keyword">const</span>;</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    <a class="code" href="class_database.html">Database&lt;SmartPointer&lt;User&gt;</a>&gt; *<a class="code" href="class_library.html#a973b2ab462d6c953575f0b2da93e4d96">getUsers</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <a class="code" href="class_database.html">Database&lt;SmartPointer&lt;Admin&gt;</a>&gt; *<a class="code" href="class_library.html#a4111051c1f0968c5663bb7fd0fef6f44">getAdmins</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    <a class="code" href="class_database.html">Database&lt;SmartPointer&lt;Book&gt;</a>&gt; *<a class="code" href="class_library.html#a77968b77aab5078fad2e3a8149f29c74">getBooks</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    <span class="keyword">friend</span> std::ostream &amp;<a class="code" href="class_library.html#a1422cce38ba96fdfc0f552bf9f557420">operator&lt;&lt;</a>(std::ostream &amp;out, <span class="keyword">const</span> <a class="code" href="class_library.html">Library</a> &amp;library);</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    <span class="keyword">friend</span> std::ostream &amp;<a class="code" href="class_library.html#a1422cce38ba96fdfc0f552bf9f557420">operator&lt;&lt;</a>(std::ostream &amp;out, <span class="keyword">const</span> <a class="code" href="class_library.html">Library</a> *library);</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    <a class="code" href="class_database.html">Database&lt;SmartPointer&lt;Book&gt;</a>&gt; *books;  <span class="comment">// list of books in library</span></div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    <a class="code" href="class_database.html">Database&lt;SmartPointer&lt;User&gt;</a>&gt; *users;  <span class="comment">// list of users in library</span></div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    <span class="keywordtype">bool</span> isTheOnlyAdminLeft(<a class="code" href="class_smart_pointer.html">SmartPointer&lt;User&gt;</a> user);</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;};</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;<span class="preprocessor">#endif // LIBRARYMGR_LIBRARY_H</span></div><div class="ttc" id="class_library_html_a9b67293035c9287e553fdf375c2c07d4"><div class="ttname"><a href="class_library.html#a9b67293035c9287e553fdf375c2c07d4">Library::isBookInDatabase</a></div><div class="ttdeci">bool isBookInDatabase(Book book) const </div><div class="ttdef"><b>Definition:</b> Library.cpp:127</div></div>
<div class="ttc" id="class_book_html"><div class="ttname"><a href="class_book.html">Book</a></div><div class="ttdoc">Library book with author, ISBN and status. </div><div class="ttdef"><b>Definition:</b> Book.h:28</div></div>
<div class="ttc" id="class_library_html_a973b2ab462d6c953575f0b2da93e4d96"><div class="ttname"><a href="class_library.html#a973b2ab462d6c953575f0b2da93e4d96">Library::getUsers</a></div><div class="ttdeci">Database&lt; SmartPointer&lt; User &gt; &gt; * getUsers() const </div><div class="ttdoc">getUsers gets users (also admins) of library </div><div class="ttdef"><b>Definition:</b> Library.cpp:85</div></div>
<div class="ttc" id="class_library_html_a983f569333bcca8e312e28faf4c31299"><div class="ttname"><a href="class_library.html#a983f569333bcca8e312e28faf4c31299">Library::editBook</a></div><div class="ttdeci">void editBook(SmartPointer&lt; Book &gt; oldBook, SmartPointer&lt; Book &gt; newBook)</div><div class="ttdoc">replaces selected book with new one </div><div class="ttdef"><b>Definition:</b> Library.cpp:73</div></div>
<div class="ttc" id="class_library_html_a77968b77aab5078fad2e3a8149f29c74"><div class="ttname"><a href="class_library.html#a77968b77aab5078fad2e3a8149f29c74">Library::getBooks</a></div><div class="ttdeci">Database&lt; SmartPointer&lt; Book &gt; &gt; * getBooks() const </div><div class="ttdoc">getBooks gets books in library </div><div class="ttdef"><b>Definition:</b> Library.cpp:108</div></div>
<div class="ttc" id="class_user_html"><div class="ttname"><a href="class_user.html">User</a></div><div class="ttdef"><b>Definition:</b> User.h:31</div></div>
<div class="ttc" id="class_library_html_a4111051c1f0968c5663bb7fd0fef6f44"><div class="ttname"><a href="class_library.html#a4111051c1f0968c5663bb7fd0fef6f44">Library::getAdmins</a></div><div class="ttdeci">Database&lt; SmartPointer&lt; Admin &gt; &gt; * getAdmins() const </div><div class="ttdoc">getUsers gets admins of library </div><div class="ttdef"><b>Definition:</b> Library.cpp:89</div></div>
<div class="ttc" id="class_library_html_a1422cce38ba96fdfc0f552bf9f557420"><div class="ttname"><a href="class_library.html#a1422cce38ba96fdfc0f552bf9f557420">Library::operator&lt;&lt;</a></div><div class="ttdeci">friend std::ostream &amp; operator&lt;&lt;(std::ostream &amp;out, const Library &amp;library)</div><div class="ttdoc">operator &lt;&lt; printer </div><div class="ttdef"><b>Definition:</b> Library.cpp:112</div></div>
<div class="ttc" id="class_library_html_ad102e94fb61ef4db352769970c470ffe"><div class="ttname"><a href="class_library.html#ad102e94fb61ef4db352769970c470ffe">Library::editUser</a></div><div class="ttdeci">void editUser(SmartPointer&lt; User &gt; oldUser, SmartPointer&lt; User &gt; newUser)</div><div class="ttdoc">replaces selected user with new one </div><div class="ttdef"><b>Definition:</b> Library.cpp:69</div></div>
<div class="ttc" id="class_library_html_a62120f28a9b50cc5b151d868e42ab936"><div class="ttname"><a href="class_library.html#a62120f28a9b50cc5b151d868e42ab936">Library::~Library</a></div><div class="ttdeci">~Library()</div><div class="ttdef"><b>Definition:</b> Library.cpp:31</div></div>
<div class="ttc" id="class_library_html_a82338219d8bf51962ff5f60a0db21b19"><div class="ttname"><a href="class_library.html#a82338219d8bf51962ff5f60a0db21b19">Library::Library</a></div><div class="ttdeci">Library()</div><div class="ttdef"><b>Definition:</b> Library.cpp:21</div></div>
<div class="ttc" id="class_library_html_a237a223c72cc9c46efbc70b05bfc4067"><div class="ttname"><a href="class_library.html#a237a223c72cc9c46efbc70b05bfc4067">Library::removeUser</a></div><div class="ttdeci">bool removeUser(SmartPointer&lt; User &gt; user)</div><div class="ttdef"><b>Definition:</b> Library.cpp:41</div></div>
<div class="ttc" id="class_database_html"><div class="ttname"><a href="class_database.html">Database</a></div><div class="ttdoc">Abstract collection of object. </div><div class="ttdef"><b>Definition:</b> Database.h:30</div></div>
<div class="ttc" id="class_library_html_a553976ddb2812ca85f16d98e747e7e69"><div class="ttname"><a href="class_library.html#a553976ddb2812ca85f16d98e747e7e69">Library::removeBook</a></div><div class="ttdeci">bool removeBook(SmartPointer&lt; Book &gt; book)</div><div class="ttdoc">removes book from library </div><div class="ttdef"><b>Definition:</b> Library.cpp:54</div></div>
<div class="ttc" id="class_library_html_a525d14bedae90669616814e7bc8b64d2"><div class="ttname"><a href="class_library.html#a525d14bedae90669616814e7bc8b64d2">Library::findUser</a></div><div class="ttdeci">SmartPointer&lt; User &gt; findUser(SmartPointer&lt; User &gt; user) const </div><div class="ttdoc">findUser finds users matching query </div><div class="ttdef"><b>Definition:</b> Library.cpp:77</div></div>
<div class="ttc" id="class_library_html_a1e4254bc287282e010057c3e5badb43b"><div class="ttname"><a href="class_library.html#a1e4254bc287282e010057c3e5badb43b">Library::findBook</a></div><div class="ttdeci">SmartPointer&lt; Book &gt; findBook(SmartPointer&lt; Book &gt; book) const </div><div class="ttdoc">findBook finds books matching query </div><div class="ttdef"><b>Definition:</b> Library.cpp:81</div></div>
<div class="ttc" id="class_smart_pointer_html"><div class="ttname"><a href="class_smart_pointer.html">SmartPointer</a></div><div class="ttdef"><b>Definition:</b> SmartPointer.h:27</div></div>
<div class="ttc" id="class_library_html_a578ce2622f10276289f4818f745ab67e"><div class="ttname"><a href="class_library.html#a578ce2622f10276289f4818f745ab67e">Library::isUserInDatabase</a></div><div class="ttdeci">bool isUserInDatabase(User user) const </div><div class="ttdef"><b>Definition:</b> Library.cpp:123</div></div>
<div class="ttc" id="class_library_html_ad6479360c5ecb4592ab7df4cedc1d331"><div class="ttname"><a href="class_library.html#ad6479360c5ecb4592ab7df4cedc1d331">Library::addUser</a></div><div class="ttdeci">void addUser(SmartPointer&lt; User &gt; user)</div><div class="ttdoc">adds new user to library </div><div class="ttdef"><b>Definition:</b> Library.cpp:33</div></div>
<div class="ttc" id="class_library_html_ae18b352bb538f8f7bbef5eba963feec6"><div class="ttname"><a href="class_library.html#ae18b352bb538f8f7bbef5eba963feec6">Library::addBook</a></div><div class="ttdeci">void addBook(SmartPointer&lt; Book &gt; book)</div><div class="ttdoc">adds new book to library </div><div class="ttdef"><b>Definition:</b> Library.cpp:37</div></div>
<div class="ttc" id="class_library_html"><div class="ttname"><a href="class_library.html">Library</a></div><div class="ttdoc">model of library with users and books </div><div class="ttdef"><b>Definition:</b> Library.h:31</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d422163b96683743ed3963d4aac17747.html">app</a></li><li class="navelem"><a class="el" href="dir_161740fb8b86334a586a3e266d14a5bf.html">Library</a></li><li class="navelem"><b>Library.h</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
